public abstract class NAire implements Expr{

    private Expr[] ops;
    
    protected NAire(Expr[] ops){
	this.ops = ops;
    }

    public Expr[] getOps(){
	return ops;
    }

    public double evaluer(Contexte c){
	double[] d = new double[getOps().length];
	for (int i = 0; i<getOps().length; i++)
	    d[i]=getOps()[i].evaluer(c);
	    
	return calculer(d);
    }

    public String decompiler(){
	String s = getOp()+"(";
	for (Expr e : getOps())
	    s+=e.decompiler()+",";
	
	return s.substring(0,s.length()-1)+")";
    }

    public abstract String getOp();
    public abstract double calculer(double[] v);
}
